minor fixes
[buildscripts] / tor-browser
index 518d8a99e820ad0cebb78f660d54b751b8dfc994..df4dd8c4533093799d790b21147a57f674071a0d 100755 (executable)
@@ -1,4 +1,4 @@
-#!/bin/bash -l
+#!/bin/bash
 # Copyright (C) 2016 Ian Kelling
 
 # Licensed under the Apache License, Version 2.0 (the "License");
 # See the License for the specific language governing permissions and
 # limitations under the License.
 
-set -eE -o pipefail
-trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?"' ERR
+if [[ -s ~/.bashrc ]];then . ~/.bashrc;fi
 
 
 # stable version is shown on:
 # https://dist.torproject.org/torbrowser/
+# except sometimes you get a new stable before it's
+# officially released, which is ok by me. for example,
+# right now, it has 6.5.2, but stable is 6.5.1.
+# we exclude verions with letters, as that seems to
+# be a relatively reliable indication of alpha/beta releases.
+
+vers=($(curl -s https://dist.torproject.org/torbrowser/ \
+          | sed -rn 's#.*href="([0-9]+\.[0-9]+[.0-9]*)/.*#\1#p' \
+          | sort -Vr))
 
-ver=$(curl -s https://dist.torproject.org/torbrowser/ \
-          | sed -rn 's/.*href="([0-9]+\.[0-9]+[.0-9]*)\/.*/\1/p' \
-          | sort -Vr | head -n 1)
 
 
 # by default it has perms for just 1 non-root user, which is ok for now.
 
 cd /a/opt
 
-f=tor-browser-linux64-${ver}_en-US.tar.xz
-timestamp=$(stat -c %Y $f) ||:
-wget -N https://www.torproject.org/dist/torbrowser/$ver/$f
-new_timestamp=$(stat -c %Y $f) ||:
+ver=${vers[0]}
+dl() {
+  f=tor-browser-linux64-${ver}_en-US.tar.xz
+  if [[ -e $f ]]; then
+    timestamp=$(stat -c %Y $f)
+  else
+    timestamp=0
+  fi
+  echo wget -nv -N https://www.torproject.org/dist/torbrowser/$ver/$f
+  wget -nv -N https://www.torproject.org/dist/torbrowser/$ver/$f || ret=$?
+}
+dl
+# 8 is return code for 404. for a new release, they might not have released to linux yet.
+if [[ $ret == 8 ]]; then
+  ver=${vers[1]}
+  dl
+fi
+
+new_timestamp=$(stat -c %Y $f)
 if [[ $timestamp != $new_timestamp || ! -e /a/opt/tor-browser_en-US/Browser/start-tor-browser ]]; then
-   # not already installed
-    rm -rf tor-browser_en-US
-    ex $f
+  # not already installed
+  rm -rf tor-browser_en-US
+  tar Jxf $f
+
+  ## begin handlers customization
+  dest=/a/opt/tor-browser_en-US/Browser/TorBrowser/Data/Browser/profile.default/handlers.json
+  orig=/p/c/tor-handlers-orig.json
+  src=/p/c/tor-handlers.json
+  if diff -q $src $dest; then
+    echo "Error: handlers file changed. adjust based on upstream"
+    exit 1
+  fi
+  cp $src $dest
+  ## end handlers customization
+
+  cp /p/c/tor-user.js /a/opt/tor-browser_en-US/Browser/TorBrowser/Data/Browser/profile.default/user.js
+
 fi
 
 for x in tor-*.tar.xz; do
-    # cleanup old tarballs
-    [[ -e $x ]] || break
-    [[ $x != $f ]] || continue
-    command rm -f $x
+  # cleanup old tarballs
+  [[ -e $x ]] || break
+  [[ $x != $f ]] || continue
+  command rm -f $x
 done
-s lnf /a/opt/tor-browser_en-US/Browser/start-tor-browser /usr/local/bin